const target_first = document.body;

const observer_first = new MutationObserver(records => {
  //console.log('--- DOM change is detected ---\n');
  records.forEach(record => {
    //console.log(record.addedNodes);
    if(record.addedNodes.length != 0){
      record.addedNodes.forEach(node => {
        //console.log(node.nodeName + ' / ' + node.className);
        if(node.nodeName === 'DIV' && node.className === 'pp_overlay'){
          const waitObjectLoadTimer = setInterval(waitObjectLoad, 1000);
          function waitObjectLoad(){
            if(document.getElementById('typing_content') != null){
              clearInterval(waitObjectLoadTimer);
              callObserverSecond();
            }
          }
        }
      });
    }
  });
});

observer_first.observe(target_first, {
  childList: true
});

function callObserverSecond(){
  console.log('--- ety start is detected ---\n')

  const ety_display = document.getElementById('typing_content');
  const ety_display_document = ety_display.contentDocument || ety_display.contentWindow.document;
  const target_second = ety_display_document.getElementById('app');

  let isFinished = false;

  function finalizeData(){
    console.log('--- Trial is finished ---\n');
    isFinished = true;
  }

  function displayDataInit(){
    const ety_display = document.getElementById('typing_content');
    const ety_display_document = ety_display.contentDocument || ety_display.contentWindow.document;
    const waitObjectLoadTimer = setInterval(waitObjectLoad, 100);
    function waitObjectLoad(){
      if(ety_display_document.getElementById('exampleList') != null){
        clearInterval(waitObjectLoadTimer);
        displayData();
      }
    }
  }

  function displayData(){
    console.log('--- Result detail is showed ---\n');
    autoRun();
  }

  const observer_second = new MutationObserver(records => {
    records.forEach(record => {
      switch(record.type) {
        case 'childList':
          console.log(record.addedNodes.innerHTML);
          if(record.addedNodes.length != 0){
            record.addedNodes.forEach(node => {
              if(node.nodeName === 'DIV' && node.id === 'result'){
                // show result display
                console.log('--- Result is detected ---\n');
                finalizeData();
                displayDataInit();
              }
            });
          }
          break;
      }
    });
  });

  observer_second.observe(target_second, {
    childList: true,
  });

}